<?php
/***************************************************************************
 *   @brief WP-Sentinel - Wordpress Security System .                      *
 *   @author Simone Margaritelli (aka evilsocket) <evilsocket@gmail.com>   *
 *                       		                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
require_once("../../../wp-config.php");

if( !current_user_can('manage_options') ){
	die( "You don't have privileges to do this!" ); 
}

$action  = isset($_GET['action']) ? $_GET['action'] : 'daily';
$logpath = ABSPATH."wp-content/plugins/wp-sentinel/log/";

switch( $action ){
	// download daily log
	case 'daily' :
		$filename		= strftime("log_%y%m%d.xml.php");
		$daily_log_path = $logpath . $filename;
		if( !file_exists($daily_log_path) ){
			die( "No activities today." );
		}
		
		$data = file_get_contents($daily_log_path);
		// remove first php line
		$data = trim( str_replace( "<?php die(); ?>", "", $data ) );
		
		header("Cache-Control: public");
  		header("Content-Description: File Transfer");
  		header("Content-Disposition: attachment; filename= dailylog.xml");
  		header("Content-Transfer-Encoding: binary");
  	  	
  	  	die($data);
	break;
	// archive and download every log
	case 'full' :
		$data	= "";
		$handle = opendir($logpath);
    	while (false !== ($file = readdir($handle))) {
    		if( preg_match( "/log_[\d]+\.xml\.php/", $file ) ){
    			$xml = file_get_contents($logpath.$file);
    			// remove php header
				$xml = str_replace( "<?php die(); ?>", "", $xml );
    			// remove xml header
    			$xml = str_replace( "<?xml version=\"1.0\" encoding=\"utf-8\"?>", "", $xml );

    			$data .= $xml;
    		}
        }
    	closedir($handle);
    	
    	header("Cache-Control: public");
  		header("Content-Description: File Transfer");
  		header("Content-Disposition: attachment; filename= fulllog.xml");
  		header("Content-Transfer-Encoding: binary");
  	  	
  	  	die( "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<alarms>\n$data\n</alarms>"); 	
  	 break;
}

?>