<?php
/***************************************************************************
 *   @brief WP-Sentinel - Wordpress Security System .                      *
 *   @author Simone Margaritelli (aka evilsocket) <evilsocket@gmail.com>   *
 *                       		                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

class WPS_Log {
	private $logpath;
	private $logname;
	private $fullname;
	private $firstentry;
	
	public function __construct(){
		$this->logpath  = ABSPATH."wp-content/plugins/wp-sentinel/log";
		$this->logname  = strftime("log_%y%m%d.xml.php");
		$this->fullname = $this->logpath."/".$this->logname;
		
		if( @file_exists($this->fullname) ){
			$this->firstentry = false;
		}
		else{
			/* create the file */
			fclose( fopen( $this->fullname, "w+t" ) );
			$this->firstentry = true;
		}
	}
		
	public function log( $wpuser, $scope, $variable, $content, $message, $rule ){
		$address  = $_SERVER['REMOTE_ADDR'];
		$agent    = htmlentities($_SERVER['HTTP_USER_AGENT']);
		$referer  = htmlentities($_SERVER['HTTP_REFERER']);
		$username = (isset($wpuser->user_level) ? htmlentities($wpuser->user_login) : "");
		
		if( $this->firstentry ){
			$fd = @fopen( $this->fullname, "w+t" );
			@fputs( $fd, "<?php die(); ?>\n".
			             "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n".
			             "<alarm>\n".
						 "	<time>".time()."</time>\n".
						 "	<address>".$address."</address>\n".
						 "	<agent>".$agent."</agent>\n".
						 "	<referer>".$referer."</referer>\n".
						 "	<username>".$username."</username>\n".
						 "	<scope>".$scope."</scope>\n".
						 "	<variable>".htmlentities($variable)."</variable>\n".
						 "	<content>".htmlentities($content)."</content>\n".
						 "	<message>".htmlentities($message)."</message>\n".
						 "	<rule>".htmlentities($rule)."</rule>\n".
						 "</alarm>\n" );
			@fclose($fd);
		}
		else{
			$fd = @fopen( $this->fullname, "a+t" );
			@fputs( $fd, "<alarm>\n".
						 "	<time>".time()."</time>\n".
						 "	<address>".$address."</address>\n".
						 "	<agent>".$agent."</agent>\n".
						 "	<referer>".$referer."</referer>\n".
						 "	<username>".$username."</username>\n".
						 "	<scope>".$scope."</scope>\n".
						 "	<variable>".htmlentities($variable)."</variable>\n".
						 "	<content>".htmlentities($content)."</content>\n".
						 "	<message>".htmlentities($message)."</message>\n".
						 "	<rule>".htmlentities($rule)."</rule>\n".
						 "</alarm>\n" );
			@fclose($fd);
		}
	}
}
	
?>